Index: trunk/src/VBox/VMM/VMMAll/APICAll.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMAll/APICAll.cpp	(revision 99737)
+++ trunk/src/VBox/VMM/VMMAll/APICAll.cpp	(revision 99739)
@@ -3429,5 +3429,4 @@
  * Posts an interrupt to a target APIC, Hyper-V interface.
  *
- * @returns true if the interrupt was accepted, false otherwise.
  * @param   pVCpu               The cross context virtual CPU structure.
  * @param   uVector             The vector of the interrupt to be posted.
Index: trunk/src/VBox/VMM/VMMAll/CPUMAllRegs.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMAll/CPUMAllRegs.cpp	(revision 99737)
+++ trunk/src/VBox/VMM/VMMAll/CPUMAllRegs.cpp	(revision 99739)
@@ -1728,5 +1728,4 @@
  * Mark the guest's debug state as inactive.
  *
- * @returns boolean
  * @param   pVCpu       The cross context virtual CPU structure of the calling EMT.
  * @todo    This API doesn't make sense any more.
Index: trunk/src/VBox/VMM/VMMAll/DBGFAllTracer.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMAll/DBGFAllTracer.cpp	(revision 99737)
+++ trunk/src/VBox/VMM/VMMAll/DBGFAllTracer.cpp	(revision 99739)
@@ -190,5 +190,4 @@
  * Copies the given MMIO value into the event descriptor based on the given size.
  *
- * @returns nothing.
  * @param   pEvtMmio                Pointer to the MMIO event descriptor to fill.
  * @param   pvVal                   The value to copy.
@@ -220,5 +219,4 @@
  * Copies the given I/O port value into the event descriptor based on the given size.
  *
- * @returns nothing.
  * @param   pEvtIoPort              Pointer to the I/O port read/write event descriptor to fill.
  * @param   pvVal                   The value to copy.
Index: trunk/src/VBox/VMM/VMMAll/HMAll.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMAll/HMAll.cpp	(revision 99737)
+++ trunk/src/VBox/VMM/VMMAll/HMAll.cpp	(revision 99739)
@@ -389,5 +389,4 @@
  * Queues a guest page for invalidation.
  *
- * @returns VBox status code.
  * @param   pVCpu       The cross context virtual CPU structure.
  * @param   GCVirt      Page to invalidate.
Index: trunk/src/VBox/VMM/VMMAll/IEMAll.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMAll/IEMAll.cpp	(revision 99737)
+++ trunk/src/VBox/VMM/VMMAll/IEMAll.cpp	(revision 99739)
@@ -567,5 +567,4 @@
  * This is called internally as well as by PGM when moving GC mappings.
  *
- * @returns
  * @param   pVCpu       The cross context virtual CPU structure of the calling
  *                      thread.
@@ -6776,5 +6775,4 @@
  * The caller shall only call this after checking cActiveMappings.
  *
- * @returns Strict VBox status code to pass up.
  * @param   pVCpu       The cross context virtual CPU structure of the calling thread.
  */
Index: trunk/src/VBox/VMM/VMMAll/PGMAll.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMAll/PGMAll.cpp	(revision 99737)
+++ trunk/src/VBox/VMM/VMMAll/PGMAll.cpp	(revision 99739)
@@ -3858,5 +3858,4 @@
  * Release the PGM lock.
  *
- * @returns VBox status code
  * @param   pVM         The cross context VM structure.
  */
Index: trunk/src/VBox/VMM/VMMAll/PGMAllHandler.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMAll/PGMAllHandler.cpp	(revision 99737)
+++ trunk/src/VBox/VMM/VMMAll/PGMAllHandler.cpp	(revision 99739)
@@ -987,6 +987,4 @@
  * Resets ram range flags.
  *
- * @returns VBox status code.
- * @retval  VINF_SUCCESS when shadow PTs was successfully updated.
  * @param   pVM     The cross context VM structure.
  * @param   pCur    The physical handler.
Index: trunk/src/VBox/VMM/VMMAll/PGMAllPhys.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMAll/PGMAllPhys.cpp	(revision 99737)
+++ trunk/src/VBox/VMM/VMMAll/PGMAllPhys.cpp	(revision 99739)
@@ -1210,6 +1210,4 @@
 /**
  * Deal with a write monitored page.
- *
- * @returns VBox strict status code.
  *
  * @param   pVM         The cross context VM structure.
Index: trunk/src/VBox/VMM/VMMR0/CPUMR0.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMR0/CPUMR0.cpp	(revision 99737)
+++ trunk/src/VBox/VMM/VMMR0/CPUMR0.cpp	(revision 99739)
@@ -773,5 +773,4 @@
  * Lazily sync in the hypervisor debug state
  *
- * @returns VBox status code.
  * @param   pVCpu       The cross context virtual CPU structure of the calling EMT.
  * @param   fDr6        Whether to include DR6 or not.
Index: trunk/src/VBox/VMM/VMMR0/DBGFR0Bp.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMR0/DBGFR0Bp.cpp	(revision 99737)
+++ trunk/src/VBox/VMM/VMMR0/DBGFR0Bp.cpp	(revision 99739)
@@ -57,5 +57,4 @@
  * Used by DBGFR0InitPerVM() to initialize the breakpoint manager.
  *
- * @returns nothing.
  * @param   pGVM        The global (ring-0) VM structure.
  */
Index: trunk/src/VBox/VMM/VMMR0/HMSVMR0.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMR0/HMSVMR0.cpp	(revision 99737)
+++ trunk/src/VBox/VMM/VMMR0/HMSVMR0.cpp	(revision 99739)
@@ -1734,5 +1734,4 @@
  * Exports the guest (or nested-guest) segment registers into the VMCB.
  *
- * @returns VBox status code.
  * @param   pVCpu       The cross context virtual CPU structure.
  * @param   pVmcb       Pointer to the VM control block.
@@ -5607,5 +5606,4 @@
  * for re-entry next time around.
  *
- * @returns Strict VBox status code (i.e. informational status codes too).
  * @param   pSvmTransient   The SVM-transient structure.
  * @param   pDbgState       The debug state.
Index: trunk/src/VBox/VMM/VMMR0/HMVMXR0.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMR0/HMVMXR0.cpp	(revision 99737)
+++ trunk/src/VBox/VMM/VMMR0/HMVMXR0.cpp	(revision 99739)
@@ -940,5 +940,4 @@
  * Free all VT-x structures for the VM.
  *
- * @returns IPRT status code.
  * @param   pVM     The cross context VM structure.
  */
@@ -1604,5 +1603,4 @@
  * Flushes the TLB using EPT.
  *
- * @returns VBox status code.
  * @param   pVCpu           The cross context virtual CPU structure of the calling
  *                          EMT.  Can be NULL depending on @a enmTlbFlush.
@@ -1641,5 +1639,4 @@
  * Flushes the TLB using VPID.
  *
- * @returns VBox status code.
  * @param   pVCpu           The cross context virtual CPU structure of the calling
  *                          EMT.  Can be NULL depending on @a enmTlbFlush.
@@ -4393,5 +4390,4 @@
  * VMX-preemption timer.
  *
- * @returns VBox status code.
  * @param   pVCpu           The cross context virtual CPU structure.
  * @param   pVmxTransient   The VMX-transient structure.
Index: trunk/src/VBox/VMM/VMMR0/PGMR0.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMR0/PGMR0.cpp	(revision 99737)
+++ trunk/src/VBox/VMM/VMMR0/PGMR0.cpp	(revision 99739)
@@ -166,5 +166,4 @@
  * Called at the end of the ring-0 initialization to seal access handler types.
  *
- * @returns VBox status code.
  * @param   pGVM    Pointer to the global VM structure.
  */
Index: trunk/src/VBox/VMM/VMMR3/CFGM.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMR3/CFGM.cpp	(revision 99737)
+++ trunk/src/VBox/VMM/VMMR3/CFGM.cpp	(revision 99739)
@@ -121,5 +121,4 @@
  * Free wrapper.
  *
- * @returns Pointer to the allocated memory, NULL on failure.
  * @param   pVM         The cross context VM structure, if the tree
  *                      is associated with one.
@@ -155,5 +154,4 @@
  * String free wrapper.
  *
- * @returns Pointer to the allocated memory, NULL on failure.
  * @param   pVM         The cross context VM structure, if the tree
  *                      is associated with one.
Index: trunk/src/VBox/VMM/VMMR3/CPUM-armv8.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMR3/CPUM-armv8.cpp	(revision 99737)
+++ trunk/src/VBox/VMM/VMMR3/CPUM-armv8.cpp	(revision 99739)
@@ -307,5 +307,4 @@
  * Resets the CPU.
  *
- * @returns VINF_SUCCESS.
  * @param   pVM         The cross context VM structure.
  */
@@ -632,5 +631,4 @@
  * Marks the guest debug state as active.
  *
- * @returns nothing.
  * @param   pVCpu       The cross context virtual CPU structure.
  *
@@ -649,5 +647,4 @@
  * Marks the hyper debug state as active.
  *
- * @returns nothing.
  * @param   pVCpu       The cross context virtual CPU structure.
  *
Index: trunk/src/VBox/VMM/VMMR3/CPUM.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMR3/CPUM.cpp	(revision 99737)
+++ trunk/src/VBox/VMM/VMMR3/CPUM.cpp	(revision 99739)
@@ -2498,5 +2498,4 @@
  * Resets the CPU.
  *
- * @returns VINF_SUCCESS.
  * @param   pVM         The cross context VM structure.
  */
@@ -4602,5 +4601,4 @@
  * Marks the guest debug state as active.
  *
- * @returns nothing.
  * @param   pVCpu       The cross context virtual CPU structure.
  *
@@ -4619,5 +4617,4 @@
  * Marks the hyper debug state as active.
  *
- * @returns nothing.
  * @param   pVCpu       The cross context virtual CPU structure.
  *
Index: trunk/src/VBox/VMM/VMMR3/DBGF.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMR3/DBGF.cpp	(revision 99737)
+++ trunk/src/VBox/VMM/VMMR3/DBGF.cpp	(revision 99739)
@@ -229,5 +229,4 @@
  * This is for tstCFGM and others to avoid trigger leak detection.
  *
- * @returns VBox status code.
  * @param   pUVM    The user mode VM structure.
  */
Index: trunk/src/VBox/VMM/VMMR3/DBGFR3Bp.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMR3/DBGFR3Bp.cpp	(revision 99737)
+++ trunk/src/VBox/VMM/VMMR3/DBGFR3Bp.cpp	(revision 99739)
@@ -782,5 +782,4 @@
  * Frees the given breakpoint handle.
  *
- * @returns nothing.
  * @param   pUVM                The user mode VM handle.
  * @param   hBp                 The breakpoint handle to free.
@@ -978,5 +977,4 @@
  * Frees the given breakpoint handle.
  *
- * @returns nothing.
  * @param   pUVM                The user mode VM handle.
  * @param   idxL2Tbl            The L2 table index to free.
@@ -1005,5 +1003,4 @@
  * Sets the enabled flag of the given breakpoint to the given value.
  *
- * @returns nothing.
  * @param   pBp                 The breakpoint to set the state.
  * @param   fEnabled            Enabled status.
Index: trunk/src/VBox/VMM/VMMR3/DBGFR3Flow.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMR3/DBGFR3Flow.cpp	(revision 99737)
+++ trunk/src/VBox/VMM/VMMR3/DBGFR3Flow.cpp	(revision 99739)
@@ -343,5 +343,4 @@
  * Destroys a control flow graph.
  *
- * @returns nothing.
  * @param   pThis               The control flow graph to destroy.
  */
@@ -376,5 +375,4 @@
  * Destroys a basic block.
  *
- * @returns nothing.
  * @param   pFlowBb              The basic block to destroy.
  * @param   fMayDestroyFlow      Flag whether the control flow graph container
@@ -400,5 +398,4 @@
  * Destroys a given branch table.
  *
- * @returns nothing.
  * @param   pFlowBranchTbl      The flow branch table to destroy.
  */
@@ -432,5 +429,4 @@
  * Links the given basic block into the control flow graph.
  *
- * @returns nothing.
  * @param   pThis               The control flow graph to link into.
  * @param   pFlowBb             The basic block to link.
@@ -446,5 +442,4 @@
  * Links the given branch table into the control flow graph.
  *
- * @returns nothing.
  * @param   pThis               The control flow graph to link into.
  * @param   pBranchTbl          The branch table to link.
@@ -499,5 +494,4 @@
  * Sets the given error status for the basic block.
  *
- * @returns nothing.
  * @param   pFlowBb              The basic block causing the error.
  * @param   rcError             The error to set.
@@ -2134,5 +2128,4 @@
  * Destroys a given control flow graph iterator.
  *
- * @returns nothing.
  * @param   hFlowIt              The control flow graph iterator handle.
  */
@@ -2272,5 +2265,4 @@
  * Destroys a given control flow graph branch table iterator.
  *
- * @returns nothing.
  * @param   hFlowBranchTblIt              The control flow graph branch table iterator handle.
  */
Index: trunk/src/VBox/VMM/VMMR3/DBGFR3FlowTrace.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMR3/DBGFR3FlowTrace.cpp	(revision 99737)
+++ trunk/src/VBox/VMM/VMMR3/DBGFR3FlowTrace.cpp	(revision 99739)
@@ -282,5 +282,4 @@
  * Destroys the given record.
  *
- * @returns nothing.
  * @param   pRecord                 The record to destroy.
  */
@@ -318,5 +317,4 @@
  * Destroys the given report releasing all references hold to the containing records.
  *
- * @returns nothing.
  * @param   pReport                 The report to destroy.
  */
@@ -411,5 +409,4 @@
  * Destroys the given flow trace module freeing all allocated resources.
  *
- * @returns nothing.
  * @param   pThis                   The flow trace module instance data.
  */
@@ -965,5 +962,4 @@
  * Cleans up any allocated resources for each entry in the given probe for the given range.
  *
- * @returns nothing.
  * @param   pProbe                  The probe instance.
  * @param   idxStart                Start index to clean up.
@@ -1014,5 +1010,4 @@
  * Destroys the given flow trace probe freeing all allocated resources.
  *
- * @returns nothing.
  * @param   pProbe                  The flow trace probe instance data.
  */
@@ -1151,5 +1146,4 @@
  * Recalculates the size occupied by the data of this probe for each invocation.
  *
- * @returns nothing.
  * @param   pProbe                  The probe instance.
  */
Index: trunk/src/VBox/VMM/VMMR3/DBGFR3SampleReport.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMR3/DBGFR3SampleReport.cpp	(revision 99737)
+++ trunk/src/VBox/VMM/VMMR3/DBGFR3SampleReport.cpp	(revision 99739)
@@ -263,5 +263,4 @@
  * Frees the given frame and all its descendants.
  *
- * @returns nothing.
  * @param   pFrame                  The frame to free.
  */
@@ -279,5 +278,4 @@
  * Destroys the given sample report freeing all allocated resources.
  *
- * @returns nothing.
  * @param   pThis                   The sample report instance data.
  */
@@ -364,5 +362,4 @@
  * Dumps a single given frame to the release log.
  *
- * @returns nothing.
  * @param   pHlp                    The debug info helper used for printing.
  * @param   pUVM                    The usermode VM handle.
@@ -411,5 +408,4 @@
  * each VCPU.
  *
- * @returns nothing.
  * @param   pThis                    Pointer to the sample report instance.
  */
Index: trunk/src/VBox/VMM/VMMR3/DBGFR3Tracer.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMR3/DBGFR3Tracer.cpp	(revision 99737)
+++ trunk/src/VBox/VMM/VMMR3/DBGFR3Tracer.cpp	(revision 99739)
@@ -1046,5 +1046,4 @@
  * Terminates any configured tracer for the given VM instance.
  *
- * @returns nothing.
  * @param   pVM                     The cross context VM structure.
  */
Index: trunk/src/VBox/VMM/VMMR3/DBGFR3Type.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMR3/DBGFR3Type.cpp	(revision 99737)
+++ trunk/src/VBox/VMM/VMMR3/DBGFR3Type.cpp	(revision 99739)
@@ -1227,5 +1227,4 @@
  * DBGFR3TypeQueryValByType().
  *
- * @returns nothing.
  * @param   pVal                The value to free.
  */
Index: trunk/src/VBox/VMM/VMMR3/GCM.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMR3/GCM.cpp	(revision 99737)
+++ trunk/src/VBox/VMM/VMMR3/GCM.cpp	(revision 99739)
@@ -250,5 +250,4 @@
  * Do whatever fixer-specific resetting that needs to be done.
  *
- * @returns VBox status code.
  * @param   pVM     The cross context VM structure.
  */
Index: trunk/src/VBox/VMM/VMMR3/GIM.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMR3/GIM.cpp	(revision 99737)
+++ trunk/src/VBox/VMM/VMMR3/GIM.cpp	(revision 99739)
@@ -418,5 +418,4 @@
  * and other provider-specific resets.
  *
- * @returns VBox status code.
  * @param   pVM     The cross context VM structure.
  */
Index: trunk/src/VBox/VMM/VMMR3/GMM.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMR3/GMM.cpp	(revision 99737)
+++ trunk/src/VBox/VMM/VMMR3/GMM.cpp	(revision 99739)
@@ -175,5 +175,4 @@
  * Re-prepares a GMMR0FreePages request.
  *
- * @returns VINF_SUCCESS or VERR_NO_TMP_MEMORY.
  * @param       pVM         The cross context VM structure.
  * @param       pReq        A request buffer previously returned by
Index: trunk/src/VBox/VMM/VMMR3/MM.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMR3/MM.cpp	(revision 99737)
+++ trunk/src/VBox/VMM/VMMR3/MM.cpp	(revision 99739)
@@ -536,5 +536,4 @@
  * the VM it self is at this point powered off or suspended.
  *
- * @returns VBox status code.
  * @param   pUVM        Pointer to the user mode VM structure.
  */
Index: trunk/src/VBox/VMM/VMMR3/NEMR3Native-darwin-armv8.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMR3/NEMR3Native-darwin-armv8.cpp	(revision 99737)
+++ trunk/src/VBox/VMM/VMMR3/NEMR3Native-darwin-armv8.cpp	(revision 99739)
@@ -806,5 +806,4 @@
  * Sets the given general purpose register to the given value.
  *
- * @returns nothing.
  * @param   pVCpu           The cross context virtual CPU structure of the
  *                          calling EMT.
Index: trunk/src/VBox/VMM/VMMR3/NEMR3Native-darwin.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMR3/NEMR3Native-darwin.cpp	(revision 99737)
+++ trunk/src/VBox/VMM/VMMR3/NEMR3Native-darwin.cpp	(revision 99739)
@@ -3390,5 +3390,4 @@
  * Dumps the VMCS in response to a faild hv_vcpu_run{_until}() call.
  *
- * @returns nothing.
  * @param   pVCpu           The cross context virtual CPU structure.
  */
Index: trunk/src/VBox/VMM/VMMR3/PDMAsyncCompletion.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMR3/PDMAsyncCompletion.cpp	(revision 99737)
+++ trunk/src/VBox/VMM/VMMR3/PDMAsyncCompletion.cpp	(revision 99739)
@@ -787,5 +787,4 @@
  * Called by the endpoint if a task has finished.
  *
- * @returns nothing
  * @param   pTask                     Pointer to the finished task.
  * @param   rc                        Status code of the completed request.
@@ -941,5 +940,4 @@
  * Worker terminating all endpoint classes.
  *
- * @returns nothing
  * @param   pEndpointClass    Pointer to the endpoint class to terminate.
  *
@@ -978,5 +976,4 @@
  * Records the size of the request in the statistics.
  *
- * @returns nothing.
  * @param   pEndpoint    The endpoint to register the request size for.
  * @param   cbReq        Size of the request.
@@ -1021,5 +1018,4 @@
  * Records the required processing time of a request.
  *
- * @returns nothing.
  * @param   pEndpoint    The endpoint.
  * @param   cNsRun       The request time in nanoseconds.
@@ -1234,5 +1230,4 @@
  * Deregisters advanced statistics for one endpoint.
  *
- * @returns nothing.
  * @param   pEndpoint    The endpoint to deregister the advanced statistics for.
  */
@@ -1287,5 +1282,4 @@
  * Resume worker for the async completion manager.
  *
- * @returns nothing.
  * @param   pVM The cross context VM structure.
  */
@@ -1374,5 +1368,4 @@
  * Puts a task in one of the caches.
  *
- * @returns nothing.
  * @param   pEndpoint    The endpoint the task belongs to.
  * @param   pTask        The task to cache.
@@ -1512,5 +1505,4 @@
  * Closes a endpoint waiting for any pending tasks to finish.
  *
- * @returns nothing.
  * @param   pEndpoint       Handle of the endpoint.
  */
Index: trunk/src/VBox/VMM/VMMR3/PDMAsyncCompletionFile.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMR3/PDMAsyncCompletionFile.cpp	(revision 99737)
+++ trunk/src/VBox/VMM/VMMR3/PDMAsyncCompletionFile.cpp	(revision 99739)
@@ -107,5 +107,4 @@
  * Frees a task.
  *
- * @returns nothing.
  * @param   pEndpoint    Pointer to the endpoint the segment was for.
  * @param   pTask        The task to free.
@@ -517,5 +516,4 @@
  * Destroys a async I/O manager.
  *
- * @returns nothing.
  * @param   pEpClassFile    Pointer to globals for the file endpoint class.
  * @param   pAioMgr         The async I/O manager to destroy.
Index: trunk/src/VBox/VMM/VMMR3/PDMAsyncCompletionFileNormal.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMR3/PDMAsyncCompletionFileNormal.cpp	(revision 99737)
+++ trunk/src/VBox/VMM/VMMR3/PDMAsyncCompletionFileNormal.cpp	(revision 99739)
@@ -261,5 +261,4 @@
  * between the given I/O manager and the new one.
  *
- * @returns nothing.
  * @param   pAioMgr    The I/O manager with high I/O load.
  */
@@ -543,5 +542,4 @@
  * Frees a async I/O request handle.
  *
- * @returns nothing.
  * @param   pAioMgr    The I/O manager.
  * @param   hReq       The I/O request handle to free.
Index: trunk/src/VBox/VMM/VMMR3/PDMBlkCache.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMR3/PDMBlkCache.cpp	(revision 99737)
+++ trunk/src/VBox/VMM/VMMR3/PDMBlkCache.cpp	(revision 99739)
@@ -98,5 +98,4 @@
  * Add message to the VM trace buffer.
  *
- * @returns nothing.
  * @param   pBlkCache     The block cache.
  * @param   pszFmt        The format string.
@@ -118,5 +117,4 @@
  * Decrement the reference counter of the given cache entry.
  *
- * @returns nothing.
  * @param   pEntry    The entry to release.
  */
@@ -130,5 +128,4 @@
  * Increment the reference counter of the given cache entry.
  *
- * @returns nothing.
  * @param   pEntry    The entry to reference.
  */
@@ -196,5 +193,4 @@
  * Checks consistency of a LRU list.
  *
- * @returns nothing
  * @param    pList         The LRU list to check.
  * @param    pNotInList    Element which is not allowed to occur in the list.
@@ -230,5 +226,4 @@
  * Unlinks a cache entry from the LRU list it is assigned to.
  *
- * @returns nothing.
  * @param   pEntry    The entry to unlink.
  */
@@ -285,5 +280,4 @@
  * assigned list if needed.
  *
- * @returns nothing.
  * @param    pList    List to the add entry to.
  * @param    pEntry   Entry to add.
@@ -321,5 +315,4 @@
  * Destroys a LRU list freeing all entries.
  *
- * @returns nothing
  * @param   pList    Pointer to the LRU list to destroy.
  *
@@ -622,6 +615,6 @@
  * Initiates a write I/O task for the given entry.
  *
- * @returns nothing.
- * @param    pEntry The entry to read the data from.
+ * @returns VBox status code.
+ * @param   pEntry  The entry to read the data from.
  */
 static int pdmBlkCacheEntryWriteToMedium(PPDMBLKCACHEENTRY pEntry)
@@ -686,5 +679,4 @@
  * Commit a single dirty entry to the endpoint
  *
- * @returns nothing
  * @param   pEntry    The entry to commit.
  */
@@ -701,5 +693,4 @@
  * Commit all dirty entries for a single endpoint.
  *
- * @returns nothing.
  * @param   pBlkCache    The endpoint cache to commit.
  */
@@ -758,5 +749,4 @@
  * Commit all dirty entries in the cache.
  *
- * @returns nothing.
  * @param   pCache    The global cache instance.
  */
@@ -1612,5 +1602,4 @@
  * Return the best fit cache entries for the given offset.
  *
- * @returns nothing.
  * @param   pBlkCache    The endpoint cache.
  * @param   off          The offset.
@@ -1728,10 +1717,8 @@
  * which is currently in progress.
  *
- * @returns nothing.
  * @param   pEntry      The cache entry to add the segment to.
  * @param   pWaiter     The waiter entry to add.
  */
-DECLINLINE(void) pdmBlkCacheEntryAddWaiter(PPDMBLKCACHEENTRY pEntry,
-                                           PPDMBLKCACHEWAITER pWaiter)
+DECLINLINE(void) pdmBlkCacheEntryAddWaiter(PPDMBLKCACHEENTRY pEntry, PPDMBLKCACHEWAITER pWaiter)
 {
     pWaiter->pNext = NULL;
Index: trunk/src/VBox/VMM/VMMR3/PDMNetShaper.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMR3/PDMNetShaper.cpp	(revision 99737)
+++ trunk/src/VBox/VMM/VMMR3/PDMNetShaper.cpp	(revision 99739)
@@ -400,5 +400,4 @@
  * Terminate the network shaper, groups, lock and everything.
  *
- * @returns VBox error code.
  * @param   pVM  The cross context VM structure.
  */
Index: trunk/src/VBox/VMM/VMMR3/PDMQueue.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMR3/PDMQueue.cpp	(revision 99737)
+++ trunk/src/VBox/VMM/VMMR3/PDMQueue.cpp	(revision 99739)
@@ -862,5 +862,4 @@
  * Terminate the queues, freeing any resources still allocated.
  *
- * @returns nothing.
  * @param   pVM                 The cross-context VM structure.
  */
Index: trunk/src/VBox/VMM/VMMR3/PGMPhys.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMR3/PGMPhys.cpp	(revision 99737)
+++ trunk/src/VBox/VMM/VMMR3/PGMPhys.cpp	(revision 99739)
@@ -5211,5 +5211,4 @@
  * Frees a range of ram pages, replacing them with ZERO pages; helper for PGMR3PhysFreeRamPages
  *
- * @returns VBox status code.
  * @param   pVM         The cross context VM structure.
  * @param   fInflate    Inflate or deflate memory balloon
@@ -5685,5 +5684,4 @@
  * Unmap a chunk to free up virtual address space (request packet handler for pgmR3PhysChunkMap)
  *
- * @returns VBox status code.
  * @param   pVM         The cross context VM structure.
  */
Index: trunk/src/VBox/VMM/VMMR3/TM.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMR3/TM.cpp	(revision 99737)
+++ trunk/src/VBox/VMM/VMMR3/TM.cpp	(revision 99739)
@@ -3572,6 +3572,6 @@
 
 /**
- * Helper for tmR3CpuLoadTimer.
- * @returns
+ * Helper for tmR3CpuLoadTimer. 
+ *  
  * @param   pState          The state to update.
  * @param   cNsTotal        Total time.
Index: trunk/src/VBox/VMM/include/DBGFInline.h
===================================================================
--- trunk/src/VBox/VMM/include/DBGFInline.h	(revision 99737)
+++ trunk/src/VBox/VMM/include/DBGFInline.h	(revision 99739)
@@ -36,5 +36,4 @@
  * Initializes the given L2 table entry with the given values.
  *
- * @returns nothing.
  * @param   pL2Entry            The L2 entry to intialize.
  * @param   hBp                 The breakpoint handle.
@@ -62,5 +61,4 @@
  * Updates the given L2 table entry with the new pointers.
  *
- * @returns nothing.
  * @param   pL2Entry            The L2 entry to update.
  * @param   idxL2Left           The new left L2 table index.
@@ -83,5 +81,4 @@
  * Updates the given L2 table entry with the left pointer.
  *
- * @returns nothing.
  * @param   pL2Entry            The L2 entry to update.
  * @param   idxL2Left           The new left L2 table index.
@@ -103,5 +100,4 @@
  * Updates the given L2 table entry with the right pointer.
  *
- * @returns nothing.
  * @param   pL2Entry            The L2 entry to update.
  * @param   idxL2Right          The new right L2 table index.
Index: trunk/src/VBox/VMM/include/IEMInternal-armv8.h
===================================================================
--- trunk/src/VBox/VMM/include/IEMInternal-armv8.h	(revision 99737)
+++ trunk/src/VBox/VMM/include/IEMInternal-armv8.h	(revision 99739)
@@ -742,5 +742,4 @@
 /** Hint to IEMAllInstructionPython.py that this macro should be skipped.  */
 #define IEMOPHINT_SKIP_PYTHON       RT_BIT_32(31)
-/** @} */
 
 /** @def IEM_DECL_IMPL_TYPE
Index: trunk/src/VBox/VMM/testcase/tstPDMAsyncCompletionStress.cpp
===================================================================
--- trunk/src/VBox/VMM/testcase/tstPDMAsyncCompletionStress.cpp	(revision 99737)
+++ trunk/src/VBox/VMM/testcase/tstPDMAsyncCompletionStress.cpp	(revision 99739)
@@ -532,5 +532,4 @@
  * Closes a test file.
  *
- * @returns nothing.
  * @param pTestFile    Pointer to the test file.
  */