Index: trunk/src/VBox/VMM/VMMR3/CPUM.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMR3/CPUM.cpp	(revision 99756)
+++ trunk/src/VBox/VMM/VMMR3/CPUM.cpp	(revision 99775)
@@ -1184,5 +1184,5 @@
  * @param   pszArgs     "terse", "default" or "verbose".
  */
-DECLCALLBACK(void) cpumR3InfoVmxFeatures(PVM pVM, PCDBGFINFOHLP pHlp, const char *pszArgs)
+static DECLCALLBACK(void) cpumR3InfoVmxFeatures(PVM pVM, PCDBGFINFOHLP pHlp, const char *pszArgs)
 {
     RT_NOREF(pszArgs);
Index: trunk/src/VBox/VMM/VMMR3/CPUMR3CpuId.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMR3/CPUMR3CpuId.cpp	(revision 99756)
+++ trunk/src/VBox/VMM/VMMR3/CPUMR3CpuId.cpp	(revision 99775)
@@ -3966,5 +3966,5 @@
  * @param   pMsrs               The guest MSRs.
  */
-int cpumR3LoadCpuIdInner(PVM pVM, PSSMHANDLE pSSM, uint32_t uVersion, PCPUMCPUIDLEAF paLeaves, uint32_t cLeaves, PCCPUMMSRS pMsrs)
+static int cpumR3LoadCpuIdInner(PVM pVM, PSSMHANDLE pSSM, uint32_t uVersion, PCPUMCPUIDLEAF paLeaves, uint32_t cLeaves, PCCPUMMSRS pMsrs)
 {
     AssertMsgReturn(uVersion >= CPUM_SAVED_STATE_VERSION_VER3_2, ("%u\n", uVersion), VERR_SSM_UNSUPPORTED_DATA_UNIT_VERSION);
@@ -4703,5 +4703,5 @@
  * Get L2 cache associativity.
  */
-const char *getL2CacheAss(unsigned u)
+static const char *getL2CacheAss(unsigned u)
 {
     switch (u)
Index: trunk/src/VBox/VMM/VMMR3/DBGF.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMR3/DBGF.cpp	(revision 99756)
+++ trunk/src/VBox/VMM/VMMR3/DBGF.cpp	(revision 99775)
@@ -286,5 +286,5 @@
  * @thread  EMT(pVCpu)
  */
-bool dbgfR3WaitForAttach(PVM pVM, PVMCPU pVCpu, DBGFEVENTTYPE enmEvent)
+static bool dbgfR3WaitForAttach(PVM pVM, PVMCPU pVCpu, DBGFEVENTTYPE enmEvent)
 {
     /*
Index: trunk/src/VBox/VMM/VMMR3/DBGFR3ModInMem.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMR3/DBGFR3ModInMem.cpp	(revision 99756)
+++ trunk/src/VBox/VMM/VMMR3/DBGFR3ModInMem.cpp	(revision 99775)
@@ -145,5 +145,5 @@
  * @param   cbBuf           Size of buffer.
  */
-const char *dbgfR3ModNormalizeName(const char *pszName, char *pszBuf, size_t cbBuf)
+static const char *dbgfR3ModNormalizeName(const char *pszName, char *pszBuf, size_t cbBuf)
 {
     /*
Index: trunk/src/VBox/VMM/VMMR3/DBGFR3Tracer.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMR3/DBGFR3Tracer.cpp	(revision 99756)
+++ trunk/src/VBox/VMM/VMMR3/DBGFR3Tracer.cpp	(revision 99775)
@@ -924,6 +924,6 @@
  * @param   ppDbgfTracerR3          Where to store the pointer to the tracer on success.
  */
-DECLHIDDEN(int) dbgfR3TracerCreate(PVM pVM, bool fR0Enabled, const char *pszTraceFilePath,
-                                   uint32_t cbRingBuf, PDBGFTRACERINSR3 *ppDbgfTracerR3)
+static int dbgfR3TracerCreate(PVM pVM, bool fR0Enabled, const char *pszTraceFilePath,
+                              uint32_t cbRingBuf, PDBGFTRACERINSR3 *ppDbgfTracerR3)
 {
     PDBGFTRACERINSR3 pThis = NULL;
Index: trunk/src/VBox/VMM/VMMR3/PDMAsyncCompletion.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMR3/PDMAsyncCompletion.cpp	(revision 99756)
+++ trunk/src/VBox/VMM/VMMR3/PDMAsyncCompletion.cpp	(revision 99775)
@@ -835,5 +835,5 @@
  * @param   pCfgHandle  Pointer to the CFGM tree.
  */
-int pdmR3AsyncCompletionEpClassInit(PVM pVM, PCPDMASYNCCOMPLETIONEPCLASSOPS pEpClassOps, PCFGMNODE pCfgHandle)
+static int pdmR3AsyncCompletionEpClassInit(PVM pVM, PCPDMASYNCCOMPLETIONEPCLASSOPS pEpClassOps, PCFGMNODE pCfgHandle)
 {
     /* Validate input. */
Index: trunk/src/VBox/VMM/VMMR3/PDMAsyncCompletionFile.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMR3/PDMAsyncCompletionFile.cpp	(revision 99756)
+++ trunk/src/VBox/VMM/VMMR3/PDMAsyncCompletionFile.cpp	(revision 99775)
@@ -393,8 +393,8 @@
 }
 
-int pdmacFileEpTaskInitiate(PPDMASYNCCOMPLETIONTASK pTask,
-                            PPDMASYNCCOMPLETIONENDPOINT pEndpoint, RTFOFF off,
-                            PCRTSGSEG paSegments, size_t cSegments,
-                            size_t cbTransfer, PDMACTASKFILETRANSFER enmTransfer)
+static int pdmacFileEpTaskInitiate(PPDMASYNCCOMPLETIONTASK pTask,
+                                   PPDMASYNCCOMPLETIONENDPOINT pEndpoint, RTFOFF off,
+                                   PCRTSGSEG paSegments, size_t cSegments,
+                                   size_t cbTransfer, PDMACTASKFILETRANSFER enmTransfer)
 {
     PPDMASYNCCOMPLETIONENDPOINTFILE pEpFile = (PPDMASYNCCOMPLETIONENDPOINTFILE)pEndpoint;
Index: trunk/src/VBox/VMM/VMMR3/PDMLdr.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMR3/PDMLdr.cpp	(revision 99756)
+++ trunk/src/VBox/VMM/VMMR3/PDMLdr.cpp	(revision 99775)
@@ -1101,5 +1101,5 @@
  *                          case the arch dependent install dir is searched.
  */
-char *pdmR3FileR0(const char *pszFile, const char *pszSearchPath)
+static char *pdmR3FileR0(const char *pszFile, const char *pszSearchPath)
 {
     return pdmR3File(pszFile, NULL, pszSearchPath, /*fShared=*/false);
@@ -1107,4 +1107,5 @@
 
 
+#if 0 /* unused */
 /**
  * Constructs the full filename for a RC image file.
@@ -1119,8 +1120,9 @@
  *                          case the arch dependent install dir is searched.
  */
-char *pdmR3FileRC(const char *pszFile, const char *pszSearchPath)
+static char *pdmR3FileRC(const char *pszFile, const char *pszSearchPath)
 {
     return pdmR3File(pszFile, NULL, pszSearchPath, /*fShared=*/false);
 }
+#endif
 
 